#ifndef BatchLab_Header_h
#define BatchLab_Header_h

// Inheritance :
#include <Slash/Store/IStorable.h>

namespace BatchLab {

class Header : public virtual Slash::Store::IStorable {
public: //IVisited
  virtual void* cast(const std::string&) const;
  virtual bool visit(Slash::Store::IConstVisitor&) const;
  virtual bool read(Slash::Store::IVisitor&);
public:
  Header();
  virtual ~Header();
  SLASH_STORE_HEADER
private:
  std::string fPackage;
  std::string fPackageVersion;
  std::string fAIDA_Version;
  unsigned int fDate;
};

}

#endif
