/* G.Barrand */
/* src/H5Tinit.c has to be customized too in the same way. */

#if defined(WIN32)

#include "H5pubconf_win32.h"

#elif defined(__APPLE__) && defined(__i386__)

#include "H5pubconf_macosx_intel.h"

#elif defined(__APPLE__)

#include "H5pubconf_macosx.h"

#elif defined(__CYGWIN__) && defined(__GNUC__)

/*
  Done on a 'uname -a' :
    CYGWIN_NT-5.1 <notshown> 1.5.24(0.156/4/2) 2007-01-31 10:57 i686 Cygwin
*/
#include "H5pubconf_CYGWIN.h"

#elif defined(__linux__) && defined(__x86_64__)

/*
  Done on a 'uname -a' :
    Linux <notshown> 2.6.9-34.ELlargesmp #1 SMP Tue Mar 7 15:33:33 CST 2006 x86_64 x86_64 x86_64 GNU/Linux
*/
#include "H5pubconf_Linux_x86_64.h"

#else

/* 
  Done on a 'uname -a' :
    Linux <notshown> 2.4.21-27.0.2.ELsmp #1 SMP Tue Jan 18 19:25:35 CST 2005 i686 i686 i386 GNU/Linux
*/
#include "H5pubconf_Linux.h"

#endif
