// this :
#include <Lib/valuemanip.h>

// Lib :
#include <Lib/Value.h>
#include <Lib/Array.h>
#include <Lib/smanip.h>

#define ASSIGN_ARRAY(a_what,a_f_what,a_type) \
    } else if(aV.fType==Slash::Core::IValue::a_type) {\
      aThis.u.a_f_what = new Array<a_what>(*aV.u.a_f_what);


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::assign(
 Lib::Value& aThis
,const Lib::Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aThis.fType==aV.fType) {
    aThis.reset();
    if(aV.fType==Slash::Core::IValue::STRING) {
      aThis.u.f_string = new std::string(*aV.u.f_string);

    ASSIGN_ARRAY(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
    ASSIGN_ARRAY(char,f_array_char,ARRAY_CHAR)
    ASSIGN_ARRAY(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
    ASSIGN_ARRAY(short,f_array_short,ARRAY_SHORT)
    ASSIGN_ARRAY(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
    ASSIGN_ARRAY(int,f_array_int,ARRAY_INT)
    ASSIGN_ARRAY(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
    ASSIGN_ARRAY(Slash::int64,f_array_int64,ARRAY_INT64)
    ASSIGN_ARRAY(float,f_array_float,ARRAY_FLOAT)
    ASSIGN_ARRAY(double,f_array_double,ARRAY_DOUBLE)
    ASSIGN_ARRAY(bool,f_array_bool,ARRAY_BOOL)
    ASSIGN_ARRAY(std::string,f_array_string,ARRAY_STRING)

    } else {
      aThis.u = aV.u;
    }
    return true;
  } else {
    switch(aThis.fType) {
    case Slash::Core::IValue::INT:
      break;
    case Slash::Core::IValue::DOUBLE:
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_double = aV.u.f_int;
        return true;
      case Slash::Core::IValue::UNSIGNED_SHORT :
        aThis.u.f_double = aV.u.f_unsigned_short;
        return true;
      case Slash::Core::IValue::UNSIGNED_INT:
        aThis.u.f_double = aV.u.f_unsigned_int;
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::DOUBLE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::STRING:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::STRING:
      break;
    case Slash::Core::IValue::VOID_STAR:
      break;
    case Slash::Core::IValue::UNSIGNED_INT:
      break;
    case Slash::Core::IValue::BOOL:
      break;
    case Slash::Core::IValue::SHORT:
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_short = (short)aV.u.f_int;
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::DOUBLE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_SHORT :
      case Slash::Core::IValue::UNSIGNED_INT:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::STRING:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::FLOAT:
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_float = (float)aV.u.f_int;
        return true;
      case Slash::Core::IValue::DOUBLE:
        aThis.u.f_float = (float)aV.u.f_double;
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_SHORT :
      case Slash::Core::IValue::UNSIGNED_INT:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::STRING:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::UNSIGNED_CHAR:
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_unsigned_char = (unsigned char)aV.u.f_int;
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::DOUBLE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_SHORT :
      case Slash::Core::IValue::UNSIGNED_INT:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::STRING:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::CHAR:
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_char = (char)aV.u.f_int;
        return true;
      case Slash::Core::IValue::STRING:
        if(aV.u.f_string->size()!=1) break;
        aThis.u.f_char = (*aV.u.f_string)[0];
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::DOUBLE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_SHORT :
      case Slash::Core::IValue::UNSIGNED_INT:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
      switch(aV.fType) {
      case Slash::Core::IValue::INT:
        aThis.u.f_int64 = aV.u.f_int;
        return true;
      case Slash::Core::IValue::UNSIGNED_SHORT :
        aThis.u.f_int64 = aV.u.f_unsigned_short;
        return true;
      case Slash::Core::IValue::UNSIGNED_INT:
        aThis.u.f_int64 = aV.u.f_unsigned_int;
        return true;
      case Slash::Core::IValue::NONE:
      case Slash::Core::IValue::DOUBLE:
      case Slash::Core::IValue::VOID_STAR:
      case Slash::Core::IValue::BOOL:
      case Slash::Core::IValue::SHORT:
      case Slash::Core::IValue::INT64:
      case Slash::Core::IValue::FLOAT:
      case Slash::Core::IValue::UNSIGNED_CHAR:
      case Slash::Core::IValue::CHAR:
      case Slash::Core::IValue::UNSIGNED_INT64 :
      case Slash::Core::IValue::DOUBLE_STAR:
      case Slash::Core::IValue::FLOAT_STAR:
      case Slash::Core::IValue::INT_STAR:
      case Slash::Core::IValue::STRING:
      case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
      case Slash::Core::IValue::ARRAY_CHAR:
      case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
      case Slash::Core::IValue::ARRAY_SHORT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
      case Slash::Core::IValue::ARRAY_INT:
      case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
      case Slash::Core::IValue::ARRAY_INT64:
      case Slash::Core::IValue::ARRAY_FLOAT:
      case Slash::Core::IValue::ARRAY_DOUBLE:
      case Slash::Core::IValue::ARRAY_BOOL:
      case Slash::Core::IValue::ARRAY_STRING:
        break;
      }
      break;
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    aError = std::string("Lib::valuemanip::assign :")
           + " unable to assign " + aV.stype() 
           + " to " + aThis.stype();
    aThis.setNone();
    return false;
  }
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::minus(
 Lib::Value& aThis
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    aThis.u.f_int = -aThis.u.f_int;
    return true;
  case Slash::Core::IValue::DOUBLE:
    aThis.u.f_double = -aThis.u.f_double;
    return true;
  case Slash::Core::IValue::SHORT:
    aThis.u.f_short = -aThis.u.f_short;
    return true;
  case Slash::Core::IValue::INT64:
    aThis.u.f_int64 = -aThis.u.f_int64;
    return true;
  case Slash::Core::IValue::CHAR:
    aThis.u.f_char = -aThis.u.f_char;
    return true;
  case Slash::Core::IValue::FLOAT:
    aThis.u.f_float = -1.0F * aThis.u.f_float;
    return true;
  case Slash::Core::IValue::ARRAY_DOUBLE:{
    std::vector<double>& stdv = aThis.u.f_array_double->vector();
    unsigned int number = stdv.size();
    for(unsigned int index=0;index<number;index++) stdv[index] = -stdv[index];
    return true;}
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  //case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Lib::valuemanip::minus :")
         + " can't apply on type " + aThis.stype(oType);
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::do_not(
 Lib::Value& aThis
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::BOOL:
    aThis.u.f_bool = aThis.u.f_bool?false:true;
    return true;
  case Slash::Core::IValue::INT:
  case Slash::Core::IValue::DOUBLE:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Lib::valuemanip::do_not :")
         + " can't apply on type " + aThis.stype(oType);
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::add(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_int += aV.u.f_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      int tmp = aThis.u.f_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->add(double(tmp));
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_double += aV.u.f_double;
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.u.f_double += aV.u.f_unsigned_short;
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_double += aV.u.f_unsigned_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      double tmp = aThis.u.f_double;
      //In the below this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->add(tmp);
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_unsigned_int += aV.u.f_unsigned_int;
      return true;
    //case Slash::Core::IValue::DOUBLE:{
    //  double d = aThis.u.f_unsigned_int + aV.u.f_double;
    //  if(d>=0)  {
    //    aThis.u.f_unsigned_int = (unsigned int)d;
    //    return true;
    //  }}
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      unsigned int tmp = aThis.u.f_unsigned_int;
      //In the below this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->add(double(tmp));
      return true;}
    case Slash::Core::IValue::DOUBLE:{
      double d = double(aThis.u.f_unsigned_int) + aV.u.f_double;
      aThis.set(d); //this becomes a Slash::Core::IValue::DOUBLE.
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::STRING:
    switch(aV.fType) {
    case Slash::Core::IValue::STRING:
      aThis.set((*aThis.u.f_string)+(*aV.u.f_string));
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_array_double->add(aV.u.f_int);
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_array_double->add(aV.u.f_unsigned_int);
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_array_double->add(aV.u.f_double);
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:
      if(aThis.u.f_array_double->orders()!=aV.u.f_array_double->orders()) {
        aError = "Value::add : vector orders mismatch.";
        aThis.setNone();
        return false;
      }
      aThis.u.f_array_double->add(*aV.u.f_array_double);
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  //case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::add :" )
         + " can't apply on type " + aThis.stype(oType)
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::subtract(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_int -= aV.u.f_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      int tmp = aThis.u.f_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(-1);
      aThis.u.f_array_double->add(double(tmp));
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_double -= aV.u.f_double;
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.u.f_double -= aV.u.f_unsigned_short;
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_double -= aV.u.f_unsigned_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      double tmp = aThis.u.f_double;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(-1);
      aThis.u.f_array_double->add(tmp);
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
//uuu
    //case Slash::Core::IValue::UNSIGNED_INT:
    //  aThis.u.f_unsigned_int -= aV.u.f_unsigned_int;
    //  return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      unsigned int tmp = aThis.u.f_unsigned_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(-1);
      aThis.u.f_array_double->add(double(tmp));
      return true;}
    case Slash::Core::IValue::DOUBLE:{
      double d = double(aThis.u.f_unsigned_int) - aV.u.f_double;
      aThis.set(d); //this becomes a Slash::Core::IValue::DOUBLE.
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_array_double->add(-aV.u.f_int);
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_array_double->add(-((double)aV.u.f_unsigned_int));
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_array_double->add(-aV.u.f_double);
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      if(aThis.u.f_array_double->orders()!=aV.u.f_array_double->orders()) {
        aError = "Value::subtract : vector orders mismatch.";
        aThis.setNone();
        return false;
      }
      std::vector<double>& stdv = aThis.u.f_array_double->vector();
      const std::vector<double>& stdv2 = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) { 
        stdv[index] -= stdv2[index];
      }
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  //case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::subtract :" )
         + " can't apply on type " + aThis.stype(oType)
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::multiply(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_int *= aV.u.f_int;
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_int *= (int)aV.u.f_double;
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.u.f_int *= (int)aV.u.f_float;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      int tmp = aThis.u.f_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(double(tmp));
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_double *= aV.u.f_int;
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_double *= aV.u.f_double;
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.u.f_double *= aV.u.f_unsigned_short;
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_double *= aV.u.f_unsigned_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      double tmp = aThis.u.f_double;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(tmp);
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:{
      double tmp = double(aThis.u.f_unsigned_int) * aV.u.f_double;
      aThis.set(tmp); //this becomes a Slash::Core::IValue::DOUBLE.
      return true;}

      //aThis.u.f_unsigned_int *= (unsigned int)aV.u.f_double;
      //return true;

    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_unsigned_int *= aV.u.f_unsigned_int;
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      unsigned int tmp = aThis.u.f_unsigned_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      aThis.u.f_array_double->multiply(double(tmp));
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.u.f_array_double->multiply(aV.u.f_int);
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.u.f_array_double->multiply(aV.u.f_unsigned_int);
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.u.f_array_double->multiply(aV.u.f_double);
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      if(aThis.u.f_array_double->orders()!=aV.u.f_array_double->orders()) {
        aError = "Value::multiply : vector orders mismatch.";
        aThis.setNone();
        return false;
      }
      std::vector<double>& stdv = aThis.u.f_array_double->vector();
      const std::vector<double>& stdv2 = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) { 
        stdv[index] *= stdv2[index];
      }
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  //case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::multiply :" )
         + " can't apply on type " + aThis.stype(oType)
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::divide(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      int tmp = aThis.u.f_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      if(!aThis.u.f_array_double->invert()) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      }
      aThis.u.f_array_double->multiply((double)tmp);
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      if(aV.u.f_double==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        aThis.u.f_double /= aV.u.f_double;
        return true;
      }
    case Slash::Core::IValue::UNSIGNED_INT:
      if(aV.u.f_unsigned_int==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        aThis.u.f_double /= aV.u.f_unsigned_int;
        return true;
      }
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      double tmp = aThis.u.f_double;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      if(!aThis.u.f_array_double->invert()) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      }
      aThis.u.f_array_double->multiply(tmp);
      return true;}

    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
    //case Slash::Core::IValue::UNSIGNED_INT:
    //  if(aV.u.f_unsigned_int==0) {
    //    aError = Lib_valuemanip_error_div_zero;
    //    aThis.setNone();
    //    return false;
    //  } else {
    //    //FIXME : ???
    //    aThis.set((double)(aThis.u.f_unsigned_int  / aV.u.f_unsigned_int ));
    //    return true;
    //  }
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      unsigned int tmp = aThis.u.f_unsigned_int;
      //In the below, this becomes a Slash::Core::IValue::ARRAY_DOUBLE.
      aThis.set(aV.u.f_array_double->orders(),
                aV.u.f_array_double->vector());
      if(!aThis.u.f_array_double->invert()) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      }
      aThis.u.f_array_double->multiply(double(tmp));
      return true;}

    case Slash::Core::IValue::DOUBLE:
      if(aV.u.f_double==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        double d = double(aThis.u.f_unsigned_int)/aV.u.f_double;
        aThis.set(d); //this becomes a Slash::Core::IValue::DOUBLE.
        return true;
      }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      if(aV.u.f_int==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        double value = 1./aV.u.f_int;
        aThis.u.f_array_double->multiply(value);
        return true;
      }
    case Slash::Core::IValue::UNSIGNED_INT:
      if(aV.u.f_unsigned_int==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        double value = 1./aV.u.f_unsigned_int;
        aThis.u.f_array_double->multiply(value);
        return true;
      }
    case Slash::Core::IValue::DOUBLE:
      if(aV.u.f_double==0) {
        aError = Lib_valuemanip_error_div_zero;
        aThis.setNone();
        return false;
      } else {
        aThis.u.f_array_double->multiply(1./aV.u.f_double);
        return true;
      }
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      if(aThis.u.f_array_double->orders()!=aV.u.f_array_double->orders()) {
        aError = Lib_valuemanip_error_div_zero; //FIXME : error_mismatch_orders
        aThis.setNone();
        return false;
      }
      std::vector<double>& stdv = aThis.u.f_array_double->vector();
      const std::vector<double>& stdv2 = aV.u.f_array_double->vector();
      bool has_div_zero = false;
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) { 
        if(stdv2[index]==0) {
          //FIXME : stdv[index] = nan;
          stdv[index] = 0; //PAW convention.
          has_div_zero = true;
        } else {
          stdv[index] /= stdv2[index];
        }
      }
      if(has_div_zero) {
        aError = Lib_valuemanip_error_div_zero;
        // For OpenPAW/pasigm::SIGMA, continue anyway in case of /0 errors.
        //aThis.setNone();
        //return false; //FIXME : is so, then it will stop Processor.
        return true; //FIXME : do we want that ?
      }

      return true;}

    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;

  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  //case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::divide :")
         + " can't apply on type " + aThis.stype(oType)
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_gt(
 Lib::Value& aThis
,const Lib::Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_int>aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_int>aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_int>aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_int>(int)aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_int>(int)aV.u.f_unsigned_int?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_int<=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_double>aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_double>aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_double>aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_double>aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_double>aV.u.f_unsigned_int?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_double<=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::FLOAT:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_float>aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_float>aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_float>aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_float>aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_float>aV.u.f_unsigned_int?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_float<=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::VOID_STAR:
    switch(aV.fType) {
    case Slash::Core::IValue::VOID_STAR:
      aThis.set((bool)(aThis.u.f_void_star>aV.u.f_void_star?true:false));
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_unsigned_int >aV.u.f_unsigned_int ?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)((int)aThis.u.f_unsigned_int >aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]<=aV.u.f_int) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::FLOAT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]<=aV.u.f_float) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::DOUBLE:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]<=aV.u.f_double) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::UNSIGNED_INT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]<=aV.u.f_unsigned_int ) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      const std::vector<double>& stdv2 = aV.u.f_array_double->vector();
      if(stdv.size()!=stdv2.size()) break;
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]<=stdv2[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::BOOL:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
//case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::if_gt() :")
         + " can't compare type " + aThis.stype(oType) 
         + " with type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_eq(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_int==aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_int==aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_int==aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_int==(int)aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_int==(int)aV.u.f_unsigned_int ?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_int!=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }

    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:

    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::FLOAT:
    switch(aV.fType) {
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_float==aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_float==aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_float==aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_float==aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_float==aV.u.f_unsigned_int?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_float!=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)(aThis.u.f_double==aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)(aThis.u.f_double==aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)(aThis.u.f_double==aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_SHORT :
      aThis.set((bool)(aThis.u.f_double==aV.u.f_unsigned_short?true:false));
      return true;
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_double==aV.u.f_unsigned_int ?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_double!=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::STRING:
    switch(aV.fType) {
    case Slash::Core::IValue::STRING:
      aThis.set((bool)((*aThis.u.f_string)==(*aV.u.f_string)?true:false));
      return true;
    case Slash::Core::IValue::INT:
     {int v;
      if(!Lib::smanip::toint(*aThis.u.f_string,v)) break;
      aThis.set((bool)(v==aV.u.f_int?true:false));
      return true;}
    case Slash::Core::IValue::FLOAT:
     {float v;
      if(!Lib::smanip::tofloat(*aThis.u.f_string,v)) break;
      aThis.set((bool)(v==aV.u.f_float?true:false));
      return true;}
    case Slash::Core::IValue::DOUBLE:
     {double v;
      if(!Lib::smanip::todouble(*aThis.u.f_string,v)) break;
      aThis.set((bool)(v==aV.u.f_double?true:false));
      return true;}
    case Slash::Core::IValue::UNSIGNED_INT:
     {unsigned int v;
      if(!Lib::smanip::touint(*aThis.u.f_string,v)) break;
      aThis.set((bool)(v==aV.u.f_unsigned_int ?true:false));
      return true;}
    case Slash::Core::IValue::BOOL:
     {bool v;
      if(!Lib::smanip::tobool(*aThis.u.f_string,v)) break;
      aThis.set((bool)(v==aV.u.f_bool?true:false));
      return true;}
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::VOID_STAR:
    switch(aV.fType) {
    case Slash::Core::IValue::VOID_STAR:
      aThis.set((bool)(aThis.u.f_void_star==aV.u.f_void_star?true:false));
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::UNSIGNED_INT:
    switch(aV.fType) {
    case Slash::Core::IValue::UNSIGNED_INT:
      aThis.set((bool)(aThis.u.f_unsigned_int ==aV.u.f_unsigned_int ?true:false));
      return true;
    case Slash::Core::IValue::INT:
      aThis.set((bool)((int)aThis.u.f_unsigned_int ==aV.u.f_int?true:false));
      return true;
    case Slash::Core::IValue::FLOAT:
      aThis.set((bool)((int)aThis.u.f_unsigned_int ==aV.u.f_float?true:false));
      return true;
    case Slash::Core::IValue::DOUBLE:
      aThis.set((bool)((int)aThis.u.f_unsigned_int ==aV.u.f_double?true:false));
      return true;
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aV.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(aThis.u.f_unsigned_int !=stdv[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::BOOL:
    switch(aV.fType) {
    case Slash::Core::IValue::BOOL:
      aThis.u.f_bool = ((aThis.u.f_bool==aV.u.f_bool)?true:false);
      return true;
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::ARRAY_DOUBLE:
    switch(aV.fType) {
    case Slash::Core::IValue::INT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]!=aV.u.f_int) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::FLOAT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]!=aV.u.f_float) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::DOUBLE:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]!=aV.u.f_double) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::UNSIGNED_INT:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]!=aV.u.f_unsigned_int ) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::ARRAY_DOUBLE:{
      const std::vector<double>& stdv = aThis.u.f_array_double->vector();
      const std::vector<double>& stdv2 = aV.u.f_array_double->vector();
      if(stdv.size()!=stdv2.size()) {
        aThis.set(false);
        return true;
      }
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) {
        if(stdv[index]!=stdv2[index]) {
          aThis.set(false);
          return true;
        }
      }
      aThis.set(true);
      return true;
    }
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::BOOL:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    //case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
//case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::if_eq() :")
         + " can't compare type " + aThis.stype(oType) 
         + " with type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_ne(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!if_eq(aThis,aV,aError)) return false;
  aThis.u.f_bool = (aThis.u.f_bool?false:true);
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_ge(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Value tmp(aThis);
  if(!if_eq(aThis,aV,aError)) return false;
  if(aThis.u.f_bool) return true;

  // then not equal, check gt :
  if(!if_gt(tmp,aV,aError)) return false;

  aThis.u.f_bool = tmp.u.f_bool;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_lt(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!if_ge(aThis,aV,aError)) return false;
  aThis.u.f_bool = (aThis.u.f_bool?false:true);  
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_le(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!if_gt(aThis,aV,aError)) return false;
  aThis.u.f_bool = (aThis.u.f_bool?false:true);  
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_and(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::BOOL:
    switch(aV.fType) {
    case Slash::Core::IValue::BOOL:
      aThis.u.f_bool = ((aThis.u.f_bool && aV.u.f_bool)?true:false);
      return true;
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::INT:
  case Slash::Core::IValue::DOUBLE:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT:
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::if_and :")
         + " can't apply on type " + aThis.stype(oType) 
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::if_or(
 Lib::Value& aThis
,const Value& aV
,std::string& aError
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IValue::Type oType = aThis.fType;
  switch(aThis.fType) {
  case Slash::Core::IValue::BOOL:
    switch(aV.fType) {
    case Slash::Core::IValue::BOOL:
      aThis.u.f_bool = ((aThis.u.f_bool || aV.u.f_bool)?true:false);
      return true;
    case Slash::Core::IValue::INT:
    case Slash::Core::IValue::NONE:
    case Slash::Core::IValue::DOUBLE:
    case Slash::Core::IValue::STRING:
    case Slash::Core::IValue::VOID_STAR:
    case Slash::Core::IValue::SHORT:
    case Slash::Core::IValue::INT64:
    case Slash::Core::IValue::FLOAT:
    case Slash::Core::IValue::UNSIGNED_CHAR:
    case Slash::Core::IValue::CHAR:
    case Slash::Core::IValue::UNSIGNED_SHORT :
    case Slash::Core::IValue::UNSIGNED_INT64 :
    case Slash::Core::IValue::DOUBLE_STAR:
    case Slash::Core::IValue::FLOAT_STAR:
    case Slash::Core::IValue::INT_STAR:
    case Slash::Core::IValue::UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
    case Slash::Core::IValue::ARRAY_CHAR:
    case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
    case Slash::Core::IValue::ARRAY_SHORT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
    case Slash::Core::IValue::ARRAY_INT:
    case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
    case Slash::Core::IValue::ARRAY_INT64:
    case Slash::Core::IValue::ARRAY_FLOAT:
    case Slash::Core::IValue::ARRAY_DOUBLE:
    case Slash::Core::IValue::ARRAY_BOOL:
    case Slash::Core::IValue::ARRAY_STRING:
      break;
    }
    break;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::INT:
  case Slash::Core::IValue::DOUBLE:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::SHORT:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::FLOAT:
  case Slash::Core::IValue::UNSIGNED_CHAR:
  case Slash::Core::IValue::CHAR:
  case Slash::Core::IValue::UNSIGNED_SHORT :
  case Slash::Core::IValue::UNSIGNED_INT:
  case Slash::Core::IValue::UNSIGNED_INT64 :
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aError = std::string("Value::if_or :")
         + " can't apply on type " + aThis.stype(oType) 
         + " and type " + aV.stype();
  aThis.setNone();
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::to_double(
 const Lib::Value& aThis
,double& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  switch(aThis.fType) {
  case Slash::Core::IValue::INT:
    aValue = aThis.u.f_int;
    return true;
  case Slash::Core::IValue::DOUBLE:
    aValue = aThis.u.f_double;
    return true;
  case Slash::Core::IValue::UNSIGNED_SHORT:
    aValue = aThis.u.f_unsigned_short;
    return true;
  case Slash::Core::IValue::UNSIGNED_INT:
    aValue = aThis.u.f_unsigned_int;
    return true;
  case Slash::Core::IValue::SHORT:
    aValue = aThis.u.f_short;
    return true;
  case Slash::Core::IValue::INT64:
    aValue = (double)aThis.u.f_int64;
    return true;
  case Slash::Core::IValue::UNSIGNED_INT64:
    aValue = (double)aThis.u.f_unsigned_int64;
    return true;
  case Slash::Core::IValue::FLOAT:
    aValue = aThis.u.f_float;
    return true;
  case Slash::Core::IValue::UNSIGNED_CHAR:
    aValue = aThis.u.f_unsigned_char;
    return true;
  case Slash::Core::IValue::CHAR:
    aValue = aThis.u.f_char;
    return true;
  case Slash::Core::IValue::BOOL:
    aValue = aThis.u.f_bool?1:0;
    return true;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::STRING:
  case Slash::Core::IValue::VOID_STAR:
  case Slash::Core::IValue::DOUBLE_STAR:
  case Slash::Core::IValue::FLOAT_STAR:
  case Slash::Core::IValue::INT_STAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    break;
  }
  aValue = 0;
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::cxx_type(
 const Lib::Value& aThis
,std::string& aValue 
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  switch(aThis.fType) {
  case Slash::Core::IValue::INT: 
    aValue = "int";
    return true;
  case Slash::Core::IValue::DOUBLE: 
    aValue = "double";
    return true;
  case Slash::Core::IValue::STRING: 
    aValue = "std::string";
    return true;
  case Slash::Core::IValue::BOOL: 
    aValue = "bool";
    return true;
  case Slash::Core::IValue::SHORT: 
    aValue = "short";
    return true;
  case Slash::Core::IValue::FLOAT: 
    aValue = "float";
    return true;
  case Slash::Core::IValue::CHAR: 
    aValue = "char";
    return true;
  case Slash::Core::IValue::UNSIGNED_CHAR: 
    aValue = "unsigned char";
    return true;
  case Slash::Core::IValue::UNSIGNED_SHORT: 
    aValue = "unsigned short";
    return true;
  case Slash::Core::IValue::UNSIGNED_INT: 
    aValue = "unsigned int";
    return true;
  case Slash::Core::IValue::VOID_STAR: 
    aValue = "void*";
    return true;
  case Slash::Core::IValue::DOUBLE_STAR: 
    aValue = "double*";
    return true;
  case Slash::Core::IValue::FLOAT_STAR: 
    aValue = "float*";
    return true;
  case Slash::Core::IValue::INT_STAR: 
    aValue = "int*";
    return true;
  case Slash::Core::IValue::NONE:
  case Slash::Core::IValue::INT64:
  case Slash::Core::IValue::UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_UNSIGNED_CHAR:
  case Slash::Core::IValue::ARRAY_CHAR:
  case Slash::Core::IValue::ARRAY_UNSIGNED_SHORT:
  case Slash::Core::IValue::ARRAY_SHORT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT:
  case Slash::Core::IValue::ARRAY_INT:
  case Slash::Core::IValue::ARRAY_UNSIGNED_INT64:
  case Slash::Core::IValue::ARRAY_INT64:
  case Slash::Core::IValue::ARRAY_FLOAT:
  case Slash::Core::IValue::ARRAY_DOUBLE:
  case Slash::Core::IValue::ARRAY_BOOL:
  case Slash::Core::IValue::ARRAY_STRING:
    aValue = "";
    return false;
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool Lib::valuemanip::set(
 Lib::Value& aThis
,const Slash::Core::IValue& aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aThis.reset();

  aThis.fType = aValue.type();

  switch(aValue.type()) {
  case Slash::Core::IValue::NONE:
    aThis.u.f_unsigned_int64 = 0;
    return true;
  case Slash::Core::IValue::CHAR:
    aThis.u.f_char = aValue.get_char();
    return true;
  case Slash::Core::IValue::SHORT:
    aThis.u.f_short = aValue.get_short();
    return true;
  case Slash::Core::IValue::INT:
    aThis.u.f_int = aValue.get_int();
    return true;
  case Slash::Core::IValue::INT64:
    aThis.u.f_int64 = aValue.get_int64();
    return true;
  case Slash::Core::IValue::UNSIGNED_INT64:
    aThis.u.f_unsigned_int64 = aValue.get_unsigned_int64();
    return true;
  case Slash::Core::IValue::UNSIGNED_CHAR:
    aThis.u.f_unsigned_char = aValue.get_unsigned_char();
    return true;
  case Slash::Core::IValue::UNSIGNED_SHORT:
    aThis.u.f_unsigned_short  = aValue.get_unsigned_short();
    return true;
  case Slash::Core::IValue::UNSIGNED_INT:
    aThis.u.f_unsigned_int  = aValue.get_unsigned_int();
    return true;
  case Slash::Core::IValue::DOUBLE_STAR:
    aThis.u.f_double_star  = aValue.get_double_star();
    return true;
  case Slash::Core::IValue::FLOAT_STAR:
    aThis.u.f_float_star  = aValue.get_float_star();
    return true;
  case Slash::Core::IValue::INT_STAR:
    aThis.u.f_int_star  = aValue.get_int_star();
    return true;
  case Slash::Core::IValue::FLOAT:
    aThis.u.f_float = aValue.get_float();
    return true;
  case Slash::Core::IValue::DOUBLE:
    aThis.u.f_double = aValue.get_double();
    return true;
  case Slash::Core::IValue::VOID_STAR:
    aThis.u.f_void_star = aValue.get_void_star();
    return true;
  case Slash::Core::IValue::BOOL:
    aThis.u.f_bool = aValue.get_bool();
    return true;
  case Slash::Core::IValue::STRING:
    aThis.u.f_string = new std::string(aValue.get_string());
    return true;

#define SET_ARRAY(a_what,a_get_what,a_f_what,a_type) \
  case Slash::Core::IValue::a_type:\
   {std::vector<unsigned int> is;\
    const std::vector<a_what>& vd = aValue.a_get_what(is);\
    aThis.u.a_f_what = new Array<a_what>();\
    if(!aThis.u.a_f_what->configure(is)) {\
      aThis.setNone();\
      return false;\
    }\
    if(!aThis.u.a_f_what->fill(vd)) {\
      aThis.setNone();\
      return false;\
    }\
    return true;}

  SET_ARRAY(unsigned char,get_array_unsigned_char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
  SET_ARRAY(char,get_array_char,f_array_char,ARRAY_CHAR)
  SET_ARRAY(unsigned short,get_array_unsigned_short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
  SET_ARRAY(short,get_array_short,f_array_short,ARRAY_SHORT)
  SET_ARRAY(unsigned int,get_array_unsigned_int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
  SET_ARRAY(int,get_array_int,f_array_int,ARRAY_INT)
  SET_ARRAY(Slash::uint64,get_array_unsigned_int64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
  SET_ARRAY(Slash::int64,get_array_int64,f_array_int64,ARRAY_INT64)
  SET_ARRAY(float,get_array_float,f_array_float,ARRAY_FLOAT)
  SET_ARRAY(double,get_array_double,f_array_double,ARRAY_DOUBLE)
  SET_ARRAY(bool,get_array_bool,f_array_bool,ARRAY_BOOL)
  SET_ARRAY(std::string,get_array_string,f_array_string,ARRAY_STRING)

  }

  aThis.setNone();
  return false;
}

//////////////////////////////////////////////////////////////////////////////
std::string Lib::valuemanip::toString(
 const Lib::Value& aThis
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string s;
  switch(aThis.fType) {
  case Slash::Core::IValue::NONE:
    smanip::printf(s,5,"(nil)");
    return s;
  case Slash::Core::IValue::INT:
    smanip::printf(s,16,"%d",aThis.u.f_int);
    return s;
  case Slash::Core::IValue::DOUBLE:
    smanip::printf(s,16,"%g",aThis.u.f_double);
    return s;
  case Slash::Core::IValue::VOID_STAR:
    smanip::printf(s,16,"0x%lx",(unsigned long)aThis.u.f_void_star);
    return s;
  case Slash::Core::IValue::UNSIGNED_SHORT:
    smanip::printf(s,16,"%u",aThis.u.f_unsigned_short);
    return s;
  case Slash::Core::IValue::UNSIGNED_INT:
    smanip::printf(s,16,"%u",aThis.u.f_unsigned_int);
    return s;
  case Slash::Core::IValue::BOOL:
    smanip::printf(s,5,"%s",aThis.u.f_bool?"true":"false");
    return s;
  case Slash::Core::IValue::SHORT:
    smanip::printf(s,16,"%d",aThis.u.f_short);
    return s;
  case Slash::Core::IValue::INT64:
    smanip::printf(s,16,LIB_INT64_FORMAT,aThis.u.f_int64);
    return s;
  case Slash::Core::IValue::UNSIGNED_INT64:
    smanip::printf(s,16,LIB_UINT64_FORMAT,aThis.u.f_unsigned_int64);
    return s;
  case Slash::Core::IValue::FLOAT:
    smanip::printf(s,16,"%g",aThis.u.f_float);
    return s;
  case Slash::Core::IValue::UNSIGNED_CHAR:
    smanip::printf(s,16,"%c",aThis.u.f_unsigned_char);
    return s;
  case Slash::Core::IValue::CHAR:
    smanip::printf(s,16,"%c",aThis.u.f_char);
    return s;
  case Slash::Core::IValue::DOUBLE_STAR:
    smanip::printf(s,16,"0x%lx",(unsigned long)aThis.u.f_double_star);
    return s;
  case Slash::Core::IValue::FLOAT_STAR:
    smanip::printf(s,16,"0x%lx",(unsigned long)aThis.u.f_float_star);
    return s;
  case Slash::Core::IValue::INT_STAR:
    smanip::printf(s,16,"0x%lx",(unsigned long)aThis.u.f_int_star);
    return s;
  case Slash::Core::IValue::STRING:
    return *aThis.u.f_string;

#define TOS_ARRAY(a_what,a_f_what,a_type) \
  case Slash::Core::IValue::a_type:\
   {const std::vector<a_what>& stdv = aThis.u.a_f_what->vector();\
    unsigned int number = stdv.size();\
    for(unsigned int index=0;index<number;index++) {\
      if(index) s+= "\n";\
      s += smanip::tostring(stdv[index]);\
    }}\
    return s;

  TOS_ARRAY(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
  TOS_ARRAY(char,f_array_char,ARRAY_CHAR)
  TOS_ARRAY(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
  TOS_ARRAY(short,f_array_short,ARRAY_SHORT)
  TOS_ARRAY(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
  TOS_ARRAY(int,f_array_int,ARRAY_INT)
  TOS_ARRAY(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
  TOS_ARRAY(Slash::int64,f_array_int64,ARRAY_INT64)
  TOS_ARRAY(float,f_array_float,ARRAY_FLOAT)
  TOS_ARRAY(double,f_array_double,ARRAY_DOUBLE)
  TOS_ARRAY(bool,f_array_bool,ARRAY_BOOL)
  TOS_ARRAY(std::string,f_array_string,ARRAY_STRING)


  }
}
