#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/Arguments.h>
#include <Lib/smanip.h>
#include <Lib/fmanip.h>

#include <Lib/smanip.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

  Lib::Arguments args(aArgc,aArgv);

  std::string fname;
  if(!args.find("-file",fname)) {
    out << "  OS> Lib_paw_set_opt -file=<source file>" 
        << Lib::endl;
    return EXIT_FAILURE;
  }

  std::vector<std::string> lines;
  if(!Lib::fmanip::read(fname,lines)) return EXIT_FAILURE;

/*SET
  for(unsigned int index=0;index<lines.size();index++) {
    std::vector<std::string> words;
    Lib::smanip::words(lines[index]," ",words);
    if(words.size()<8) continue;
    std::string label;
    for(unsigned int i=7;i<(words.size()-1);i++) {
      if(i!=7) label+= " ";
      label += words[i];
    }
    out << "  sATT->add(\"" << words[1] << "\"" 
        << ",\"" << label << "\""
        << "," << words[3] 
        << "," << words[5]
        << ",0);"
        << Lib::endl;
  }
*/

  //OPT
  for(unsigned int index=0;index<lines.size();index+=2) {
    std::string label;

    //First line :
    std::vector<std::string> words;
    Lib::smanip::words(lines[index]," ",words);
    for(unsigned int i=7;i<(words.size()-1);i++) {
      if(i!=7) label+= " ";
      label += words[i];
    }

    // Second line, rest of label :
   {std::vector<std::string> words;
    Lib::smanip::words(lines[index+1]," ",words);
    for(unsigned int i=4;i<(words.size()-1);i++) {
      label+= " ";
      label += words[i];
    }}

    out << "  sOPT->add(\"" << words[3] << "\"" 
        << ",\"" << label << "\""
        << ",\"" << words[3] << "\""
        << ",\"" << words[3] << "\""
        << ",\"" << words[5] << "\""
        << ");"
        << Lib::endl;
  }

  return EXIT_SUCCESS;
}
