// Lib :
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/Arguments.h>
#include <Lib/Debug.h>

// this :
#include <obuild/Shell.h>

//////////////////////////////////////////////////////////////////////////////
int main(
 int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  //Lib::Debug::checkByClass(true);

  bool status = true;

 {Lib::Arguments args(aArgc,aArgv);

  std::string file;
  if(!args.file(file)) file = "packages.oshell";

  obuild::Shell shell(printer);
  status = shell.setupFromFile(file);
  if(status) status = shell.start();}

  Lib::Debug::balance(printer);

  return status?EXIT_SUCCESS:EXIT_FAILURE;
}
