#!/bin/sh -f

if [ $# -ne 2 ] ; then
  echo "check_app : two arguments expected"
  exit 1
fi

obuild_check_app_what=$1
if [ "${obuild_check_app_what}" = "" ] ; then
  echo "check_app : no application given."
  exit 1
fi

obuild_check_app_comment=$2
if [ "${obuild_check_app_comment}" = "" ] ; then
  echo "check_app : no comment given."
  exit 1
fi

obuild_check_app_found=false
obuild_check_app_old_IFS="${IFS}"
IFS=:
for obuild_check_app_path in $PATH ; do
#  echo Look ${obuild_check_app_path}
  if [ -f ${obuild_check_app_path}/${obuild_check_app_what} ] ; then
#    echo Found in ${obuild_check_app_path}
    obuild_check_app_found=true
    break
  fi
done
IFS="${obuild_check_app_old_IFS}"

if [ ${obuild_check_app_found} = "false" ] ; then
  echo ${obuild_check_app_comment}
  exit 1
fi
