#ifndef BatchLab_XML_DataReader_h
#define BatchLab_XML_DataReader_h

#include <string>

namespace Slash {namespace Store {class IObject;}}

namespace BatchLab {namespace XML {class ReadContext;}}

namespace BatchLab {
namespace XML {

Slash::Store::IObject* read_Histogram1D(ReadContext&,std::string&);
Slash::Store::IObject* read_Histogram2D(ReadContext&,std::string&);
Slash::Store::IObject* read_Histogram3D(ReadContext&,std::string&);
Slash::Store::IObject* read_Profile1D(ReadContext&,std::string&);
Slash::Store::IObject* read_Profile2D(ReadContext&,std::string&);
Slash::Store::IObject* read_Tuple(ReadContext&,std::string&);
Slash::Store::IObject* read_Cloud1D(ReadContext&,std::string&);
Slash::Store::IObject* read_Cloud2D(ReadContext&,std::string&);
Slash::Store::IObject* read_Cloud3D(ReadContext&,std::string&);
Slash::Store::IObject* read_DataPointSet(ReadContext&,std::string&);
Slash::Store::IObject* read_Function(ReadContext&,std::string&);

}}

#endif
