@ECHO OFF

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package BatchLab with version v1r3p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> setup
REM # or :
REM #   DOS> setup.bat
REM # or :
REM #   DOS> call setup.bat
REM #////////////////////////////////////////////////

SET obuild_BatchLab_path=%~dp0
REM # Remove ending \obuild\
SET obuild_BatchLab_path=%obuild_BatchLab_path:~0,-8%

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%" MKDIR "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_BatchLab_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_BatchLab_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET CERNLIB_home=C:\cern\pro
:end_if_platform_1
SET obuild_platform_result=
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%" MKDIR "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_BatchLab_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_BatchLab_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  AIDA v3r2p1`) DO SET obuild_AIDA_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_AIDA_path  ECHO Can't find AIDA package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HCL v7r*`) DO SET obuild_HCL_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_HCL_path  ECHO Can't find HCL package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Slash v1r*`) DO SET obuild_Slash_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_Slash_path  ECHO Can't find Slash package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r*`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Midnight v4r*`) DO SET obuild_Midnight_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_Midnight_path  ECHO Can't find Midnight package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r*`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r*`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r*`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r*`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_BatchLab_0=%%d
cd "%obuild_BatchLab_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r*`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_BatchLab_0%"
SET obuild_pwd_BatchLab_0=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

REM # Set environment variables of this package :
SET BATCHLABROOT=%obuild_BatchLab_path%
SET SLASHROOT=%obuild_Slash_path%
SET LIBROOT=%obuild_Lib_path%
SET LIBDIRLIB=%obuild_Lib_path%\%obuild_dir_bin%
SET BATCHLABDIRLIB=%obuild_BatchLab_path%\%obuild_dir_bin%

IF DEFINED PATH GOTO else_if_path_BatchLab_7
  SET PATH=%obuild_HCL_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_7
:else_if_path_BatchLab_7
  SET PATH=%PATH%;%obuild_HCL_path%\%obuild_dir_bin%
:end_if_path_BatchLab_7

IF DEFINED PATH GOTO else_if_path_BatchLab_8
  SET PATH=%obuild_Lib_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_8
:else_if_path_BatchLab_8
  SET PATH=%PATH%;%obuild_Lib_path%\%obuild_dir_bin%
:end_if_path_BatchLab_8

IF DEFINED PATH GOTO else_if_path_BatchLab_9
  SET PATH=%obuild_Midnight_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_9
:else_if_path_BatchLab_9
  SET PATH=%PATH%;%obuild_Midnight_path%\%obuild_dir_bin%
:end_if_path_BatchLab_9

IF DEFINED PATH GOTO else_if_path_BatchLab_10
  SET PATH=%obuild_Minuit_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_10
:else_if_path_BatchLab_10
  SET PATH=%PATH%;%obuild_Minuit_path%\%obuild_dir_bin%
:end_if_path_BatchLab_10

IF DEFINED PATH GOTO else_if_path_BatchLab_11
  SET PATH=%obuild_Rio_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_11
:else_if_path_BatchLab_11
  SET PATH=%PATH%;%obuild_Rio_path%\%obuild_dir_bin%
:end_if_path_BatchLab_11

IF DEFINED PATH GOTO else_if_path_BatchLab_12
  SET PATH=%obuild_expat_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_12
:else_if_path_BatchLab_12
  SET PATH=%PATH%;%obuild_expat_path%\%obuild_dir_bin%
:end_if_path_BatchLab_12

IF DEFINED PATH GOTO else_if_path_BatchLab_13
  SET PATH=%obuild_zlib_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_13
:else_if_path_BatchLab_13
  SET PATH=%PATH%;%obuild_zlib_path%\%obuild_dir_bin%
:end_if_path_BatchLab_13

IF DEFINED PATH GOTO else_if_path_BatchLab_14
  SET PATH=%obuild_HDF5_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_14
:else_if_path_BatchLab_14
  SET PATH=%PATH%;%obuild_HDF5_path%\%obuild_dir_bin%
:end_if_path_BatchLab_14

IF DEFINED PATH GOTO else_if_path_BatchLab_15
  SET PATH=%obuild_BatchLab_path%\%obuild_dir_bin%
  GOTO end_if_path_BatchLab_15
:else_if_path_BatchLab_15
  SET PATH=%PATH%;%obuild_BatchLab_path%\%obuild_dir_bin%
:end_if_path_BatchLab_15

:obuild_return

SET obuild_BatchLab_path=

REM # FIXME SET obuild_dir_bin=

@ECHO ON
