// this :
#include <BatchLab/HDF5/ReadContext.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::HDF5::ReadContext::ReadContext(
 int aVerboseLevel
,Slash::Core::IWriter& aPrinter
,hid_t aID
,const std::string& aName
,int aVersion
,HDF5O& aHDF5O
)
:fVerboseLevel(aVerboseLevel)
,fPrinter(aPrinter)
,fID(aID)
,fName(aName)
,fVersion(aVersion)
,fHDF5O(aHDF5O)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::HDF5::ReadContext::~ReadContext(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
int BatchLab::HDF5::ReadContext::verboseLevel(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fVerboseLevel;
}
//////////////////////////////////////////////////////////////////////////////
Slash::Core::IWriter& BatchLab::HDF5::ReadContext::printer(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fPrinter;
}
//////////////////////////////////////////////////////////////////////////////
hid_t BatchLab::HDF5::ReadContext::id(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fID;
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::HDF5::ReadContext::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
int BatchLab::HDF5::ReadContext::version(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fVersion;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::HDF5::HDF5O& BatchLab::HDF5::ReadContext::helper(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fHDF5O;
}
