

#include <stdio.h>

#include <Lib/typedefs.h>

#ifndef WIN32
#include <unistd.h>
#endif

int main() {
  ::printf("bool %d\n",(int)sizeof(bool));
  ::printf("char %d\n",(int)sizeof(char));
  ::printf("short %d\n",(int)sizeof(short));
  ::printf("int %d\n",(int)sizeof(int));
  ::printf("long %d\n",(int)sizeof(long));
  ::printf("unsigned char %d\n",(int)sizeof(unsigned char));
  ::printf("unsigned short %d\n",(int)sizeof(unsigned short));
  ::printf("unsigned int %d\n",(int)sizeof(unsigned int));
  ::printf("unsigned long %d\n",(int)sizeof(unsigned long));
  ::printf("------------\n");
  ::printf("bool %d\n",(int)sizeof(bool));
  ::printf("size_t %d\n",(int)sizeof(size_t));
#ifndef WIN32
  ::printf("off_t %d\n",(int)sizeof(off_t));
#endif
  ::printf("void* %d\n",(int)sizeof(void*));
#ifdef __alpha
  ::printf
   ("(unsigned) long long not supported with ansi alpha/OSF1 cxx compiler.\n");
#else
  ::printf("long long %d\n",(int)sizeof(long long));
  ::printf("unsigned long long %d\n",(int)sizeof(unsigned long long));
#endif

  ::printf("------------\n");
  // max numbers :
 {unsigned char n = 0;
  for(unsigned int i=0;i<8;i++)  n += 1<<i;
  ::printf("max unsigned char : %u\n",n);}
 {unsigned int n = 0;
  for(unsigned int i=0;i<32;i++)  n += 1<<i;
  ::printf("max unsigned int : %u\n",n);}
 {Lib::uint64 n = 0;
  for(unsigned int i=0;i<64;i++)  n += 1<<i;
  char fmt[32];
  ::sprintf(fmt,"max uint64 : %s\n",LIB_UINT64_FORMAT);
  ::printf(fmt,n);}

#if defined(__GLIBC__)
  ::printf("__GLIBC__ : %d\n",__GLIBC__);
#endif
#if defined(__GLIBC_MINOR__)
  ::printf("__GLIBC_MINOR__ : %d\n",__GLIBC_MINOR__);
#endif

  return 0;
}


