#ifndef Midnight_Printer_h
#define Midnight_Printer_h

// Inheritance
#include <Slash/Core/IWriter.h>

namespace Midnight {

class Printer : public virtual Slash::Core::IWriter {
public: //IWriter
  virtual bool write(const std::string&);
  virtual void disable();
  virtual void enable();
  virtual bool enabled() const;
  virtual bool flush();
public:
  Printer();
  virtual ~Printer();
};

}

#endif
